Bug 989859 - Review Request: libxls - A multiplatform C/C++ library for parsing Excel files
Review Request: libxls - A multiplatform C/C++ library for parsing Excel files
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Volker Fröhlich
Fedora Extras Quality Assurance
:
: 560240 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-30 01:17 EDT by Christopher Meng
Modified: 2013-10-08 07:33 EDT (History)
4 users (show)

See Also:
Fixed In Version: libxls-1.3.4-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-30 22:16:44 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
volker27: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2013-07-30 01:17:51 EDT
Spec URL: http://cicku.me/libxls.spec
SRPM URL: http://cicku.me/libxls-1.3.4-1.fc20.src.rpm
Description: This is a library for parsing Excel (XLS) files, with a sample program 
for converting Excel files into CSV.
Fedora Account System Username: cicku
Comment 2 Christopher Meng 2013-07-31 00:28:49 EDT
(In reply to Volker Fröhlich from comment #1)
> http://fedoraproject.org/wiki/Packaging:
> Guidelines#Trademarks_in_Summary_or_Description

Aha thanks.

Will you do a full review?

SPEC/SRPM links are the same above(Just small problem I don't want to bump the version)
Comment 3 Volker Fröhlich 2013-07-31 02:35:26 EDT
https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Good_Licenses -- The license should read "BSD" in the spec file.

The example program is not part of the main package. Thus I feel, the main package description should not mention it. The summary of util says "libsndfile". I think the description doesn't really fit the util subpackage well either.

Can you run the tests?

The xls2csv binary causes my build to break with an rpath issue.
Comment 4 Christopher Meng 2013-07-31 02:51:15 EDT
(In reply to Volker Fröhlich from comment #3)
> https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Good_Licenses --
> The license should read "BSD" in the spec file.

Fixed.

> The example program is not part of the main package. Thus I feel, the main
> package description should not mention it. The summary of util says
> "libsndfile". I think the description doesn't really fit the util subpackage
> well either.

Fixed.

> Can you run the tests?

No rules for test, can you ensure?

> The xls2csv binary causes my build to break with an rpath issue.

I build the library without any problem, not sure about yours, any logs?

NEW SPEC URL: http://cicku.me/libxls.spec
NEW SRPM URL: http://cicku.me/libxls-1.3.4-2.fc20.src.rpm
Comment 5 Ralf Corsepius 2013-07-31 03:05:41 EDT
(In reply to Christopher Meng from comment #4)
> (In reply to Volker Fröhlich from comment #3)
> > https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Good_Licenses --
> > The license should read "BSD" in the spec file.
> 
> Fixed.
> 
> > The example program is not part of the main package.

Why are you shipping it?

If it's just an example, it should not be shipped as "*-util".

If it's an utility, then packaging would make sense.

Besides this, due to its small side I'd recommend to put the xls2csv into the main package instead of putting it into a "*-util" subpackage.

> > Can you run the tests?
> 
> No rules for test, can you ensure?

The rules are there ("make check"), it's just that this package is broken.
 
> > The xls2csv binary causes my build to break with an rpath issue.

During builds, binaries being linked against just having been built shared-libs occasionally require an explicit LD_LIBRARY_PATH=<path to *.so in builddir> being set.

e.g. something along the lines of 
make check LD_LIBRARY_PATH="$(pwd)/<somewhere>"
could be neccessary.

Another common issue in such situations is config-files not being found, because they are not installed, yet.

I haven't tried to check what may apply here.

> I build the library without any problem, not sure about yours, any logs?
I guess you have your package already installed and are not building in a clean environment.
Comment 6 Michael Schwendt 2013-07-31 04:01:33 EDT
> %{_bindir}/xls2csv

$ repoquery --whatprovides /usr/bin/xls2csv
catdoc-0:0.94.2-11.fc19.x86_64

$ repoquery --whatprovides /usr/bin/\*xls2csv
catdoc-0:0.94.2-11.fc19.x86_64
xls2csv-0:1.06-14.fc19.noarch
Comment 7 Volker Fröhlich 2013-07-31 12:15:30 EDT
configure: catdoc users: avoid xls2csv conflicts, use ./configure --program-prefix=lib to get libxls2csv
Comment 8 Christopher Meng 2013-07-31 22:28:17 EDT
(In reply to Volker Fröhlich from comment #7)
> configure: catdoc users: avoid xls2csv conflicts, use ./configure
> --program-prefix=lib to get libxls2csv

After a consideration, I think that I can drop the xls2csv, do you agree?
Comment 9 Volker Fröhlich 2013-08-04 14:09:54 EDT
Is it something you expect to be valuable for people? If not, drop it.
Comment 10 Christopher Meng 2013-08-04 20:50:46 EDT
Spec URL: http://cicku.me/libxls.spec
SRPM URL: http://cicku.me/libxls-1.3.4-3.fc20.src.rpm
Comment 11 Volker Fröhlich 2013-09-22 17:59:30 EDT
There are a few compiler warnings. Please tell upstream about them!

Shared-lib-calls-exit should be addressed by upstream. Please report if you haven't already.

Please see below for further tasks!

As soon as you correct the license tag, this package is APPROVED.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.

File doesn't exist, see bottom!

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)", "Unknown or generated", "BSD (4 clause)". 1 files have
     unknown license. Detailed output of licensecheck in
     /media/speicher1/makerpm/989859-libxls/licensecheck.txt

Due to getopt.c, the overall license should be stated as "BSD with advertising".

[-]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.

Builds on PPC as well!

[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

Please report the broken checks!

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libxls-1.3.4-3.fc21.x86_64.rpm
          libxls-devel-1.3.4-3.fc21.x86_64.rpm
          libxls-1.3.4-3.fc21.src.rpm
libxls.x86_64: W: spelling-error Summary(en_US) multiplatform -> multiform, formulation, formulator
libxls.x86_64: W: shared-lib-calls-exit /usr/lib64/libxlsreader.so.1.2.1 exit@GLIBC_2.2.5
libxls-devel.x86_64: W: no-documentation
libxls.src: W: spelling-error Summary(en_US) multiplatform -> multiform, formulation, formulator
3 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libxls-devel libxls
libxls-devel.x86_64: W: no-documentation
libxls.x86_64: W: spelling-error Summary(en_US) multiplatform -> multiform, formulation, formulator
libxls.x86_64: W: shared-lib-calls-exit /usr/lib64/libxlsreader.so.1.2.1 exit@GLIBC_2.2.5
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
libxls-devel (rpmlib, GLIBC filtered):
    libxls(x86-64)
    libxlsreader.so.1()(64bit)

libxls (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    rtld(GNU_HASH)



Provides
--------
libxls-devel:
    libxls-devel
    libxls-devel(x86-64)

libxls:
    libxls
    libxls(x86-64)
    libxlsreader.so.1()(64bit)



Source checksums
----------------
http://downloads.sourceforge.net/project/libxls/libxls-1.3.4.zip :
  CHECKSUM(SHA256) this package     : a68b89427109ef3226d6c93a5df08641b3e171d16c86b8dc31c8440ad8dff367
  CHECKSUM(SHA256) upstream package : a68b89427109ef3226d6c93a5df08641b3e171d16c86b8dc31c8440ad8dff367


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 989859
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 12 Christopher Meng 2013-09-22 20:34:49 EDT
*** Bug 560240 has been marked as a duplicate of this bug. ***
Comment 13 Christopher Meng 2013-09-22 20:38:24 EDT
Thanks Volker.

Upstream refuse to add copying file because he thought it's bsd licensed...

New Package SCM Request
=======================
Package Name: libxls
Short Description: A multiplatform C/C++ library for parsing Excel files
Owners: cicku
Branches: f19 f20
Comment 14 Gwyn Ciesla 2013-09-23 08:38:16 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2013-09-23 09:08:09 EDT
libxls-1.3.4-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/libxls-1.3.4-3.fc20
Comment 16 Fedora Update System 2013-09-23 09:09:38 EDT
libxls-1.3.4-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/libxls-1.3.4-3.fc19
Comment 17 Fedora Update System 2013-09-23 20:21:39 EDT
libxls-1.3.4-3.fc19 has been pushed to the Fedora 19 testing repository.
Comment 18 Fedora Update System 2013-09-30 22:16:44 EDT
libxls-1.3.4-3.fc20 has been pushed to the Fedora 20 stable repository.
Comment 19 Fedora Update System 2013-10-08 07:33:04 EDT
libxls-1.3.4-3.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.